#include <dlfcn.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <locale.h>
/*
   force locale
   based on program xkey.c by V. Wagner
*/
/*
   Devoted to Cyril Slobin for his excellent works in area
   of Russification

   Copyright (C) 1998 by V. Wagner , E. Pertsulenko
 */

Display* XOpenDisplay( _Xconst char* display_name) {
  void * handle = dlopen("libX11.so.6", RTLD_NOW | RTLD_GLOBAL);
  void *(*RealOpenDisplay)(const char*);

  if (!handle) exit(127);
  RealOpenDisplay = dlsym(handle, "XOpenDisplay");
  setlocale(LC_ALL, "");
  return (*RealOpenDisplay) (display_name);
}
